using System;
using System.Drawing;
using System.Collections;
using System.ComponentModel;
using System.Windows.Forms;
using System.Data;
using System.Windows.Forms.Design;
using System.IO;
using System.Web.UI;
using System.Drawing.Imaging;

namespace MakeWebPictures
{
	/// <summary>
	/// Summary description for Form1.
	/// </summary>
	public class Form1 : System.Windows.Forms.Form
	{
		private System.Windows.Forms.TextBox inFolderNameTextBox;
		private System.Windows.Forms.TextBox outFolderNameTextBox;
		private System.Windows.Forms.Button doItButton;
		private System.Windows.Forms.Label label2;
		private System.Windows.Forms.Label label1;
		private System.Windows.Forms.Button chooseInputFolderButton;
		private System.Windows.Forms.Button chooseOutputFolderButton;
		private System.Windows.Forms.Label label7;
		private System.Windows.Forms.Label label8;
		private System.Windows.Forms.Label picGraphicsSettingsText;
		private System.Windows.Forms.Label thumbnailGraphicsSettingsText;
		private System.Windows.Forms.Button picGraphicsSettingsButton;
		private System.Windows.Forms.Button thumbnailGraphicsSettingsButton;
		private GraphicsSettings pictureGraphicsSettings;
		private GraphicsSettings thumbnailGraphicsSettings;
		/// <summary>
		/// Required designer variable.
		/// </summary>
		private System.ComponentModel.Container components = null;

		public Form1()
		{
			//
			// Required for Windows Form Designer support
			//
			InitializeComponent();

			pictureGraphicsSettings = new GraphicsSettings(CodecChoice.jpeg, 800, 600, 80);
			thumbnailGraphicsSettings = new GraphicsSettings(CodecChoice.jpeg, 100, 100, 80);

			picGraphicsSettingsText.Text = pictureGraphicsSettings.GetSettingsAsText();
			thumbnailGraphicsSettingsText.Text = thumbnailGraphicsSettings.GetSettingsAsText();
			//
			// TODO: Add any constructor code after InitializeComponent call
			//
		}

		/// <summary>
		/// Clean up any resources being used.
		/// </summary>
		protected override void Dispose( bool disposing )
		{
			if( disposing )
			{
				if (components != null) 
				{
					components.Dispose();
				}
			}
			base.Dispose( disposing );
		}

		#region Windows Form Designer generated code
		/// <summary>
		/// Required method for Designer support - do not modify
		/// the contents of this method with the code editor.
		/// </summary>
		private void InitializeComponent()
		{
			this.inFolderNameTextBox = new System.Windows.Forms.TextBox();
			this.outFolderNameTextBox = new System.Windows.Forms.TextBox();
			this.doItButton = new System.Windows.Forms.Button();
			this.label2 = new System.Windows.Forms.Label();
			this.label1 = new System.Windows.Forms.Label();
			this.chooseInputFolderButton = new System.Windows.Forms.Button();
			this.chooseOutputFolderButton = new System.Windows.Forms.Button();
			this.label7 = new System.Windows.Forms.Label();
			this.label8 = new System.Windows.Forms.Label();
			this.picGraphicsSettingsText = new System.Windows.Forms.Label();
			this.thumbnailGraphicsSettingsText = new System.Windows.Forms.Label();
			this.picGraphicsSettingsButton = new System.Windows.Forms.Button();
			this.thumbnailGraphicsSettingsButton = new System.Windows.Forms.Button();
			this.SuspendLayout();
			// 
			// inFolderNameTextBox
			// 
			this.inFolderNameTextBox.Location = new System.Drawing.Point(128, 48);
			this.inFolderNameTextBox.Name = "inFolderNameTextBox";
			this.inFolderNameTextBox.Size = new System.Drawing.Size(488, 20);
			this.inFolderNameTextBox.TabIndex = 1;
			this.inFolderNameTextBox.Text = "";
			// 
			// outFolderNameTextBox
			// 
			this.outFolderNameTextBox.Location = new System.Drawing.Point(128, 104);
			this.outFolderNameTextBox.Name = "outFolderNameTextBox";
			this.outFolderNameTextBox.Size = new System.Drawing.Size(488, 20);
			this.outFolderNameTextBox.TabIndex = 3;
			this.outFolderNameTextBox.Text = "";
			// 
			// doItButton
			// 
			this.doItButton.Font = new System.Drawing.Font("Microsoft Sans Serif", 9.75F, System.Drawing.FontStyle.Regular, System.Drawing.GraphicsUnit.Point, ((System.Byte)(0)));
			this.doItButton.Location = new System.Drawing.Point(304, 264);
			this.doItButton.Name = "doItButton";
			this.doItButton.TabIndex = 9;
			this.doItButton.Text = "Do It!";
			this.doItButton.Click += new System.EventHandler(this.doItButton_Click);
			// 
			// label2
			// 
			this.label2.Location = new System.Drawing.Point(40, 104);
			this.label2.Name = "label2";
			this.label2.Size = new System.Drawing.Size(80, 23);
			this.label2.TabIndex = 0;
			this.label2.Text = "Output Folder";
			// 
			// label1
			// 
			this.label1.Location = new System.Drawing.Point(40, 48);
			this.label1.Name = "label1";
			this.label1.TabIndex = 0;
			this.label1.Text = "Input Folder";
			// 
			// chooseInputFolderButton
			// 
			this.chooseInputFolderButton.Location = new System.Drawing.Point(632, 48);
			this.chooseInputFolderButton.Name = "chooseInputFolderButton";
			this.chooseInputFolderButton.Size = new System.Drawing.Size(24, 23);
			this.chooseInputFolderButton.TabIndex = 2;
			this.chooseInputFolderButton.Text = "...";
			this.chooseInputFolderButton.Click += new System.EventHandler(this.chooseInputFolderButton_Click);
			// 
			// chooseOutputFolderButton
			// 
			this.chooseOutputFolderButton.Location = new System.Drawing.Point(632, 104);
			this.chooseOutputFolderButton.Name = "chooseOutputFolderButton";
			this.chooseOutputFolderButton.Size = new System.Drawing.Size(24, 23);
			this.chooseOutputFolderButton.TabIndex = 4;
			this.chooseOutputFolderButton.Text = "...";
			this.chooseOutputFolderButton.Click += new System.EventHandler(this.chooseOutputFolderButton_Click);
			// 
			// label7
			// 
			this.label7.Font = new System.Drawing.Font("Microsoft Sans Serif", 9F, (System.Drawing.FontStyle.Bold | System.Drawing.FontStyle.Underline), System.Drawing.GraphicsUnit.Point, ((System.Byte)(0)));
			this.label7.Location = new System.Drawing.Point(136, 160);
			this.label7.Name = "label7";
			this.label7.Size = new System.Drawing.Size(104, 24);
			this.label7.TabIndex = 8;
			this.label7.Text = "Pictures";
			// 
			// label8
			// 
			this.label8.Font = new System.Drawing.Font("Microsoft Sans Serif", 9F, (System.Drawing.FontStyle.Bold | System.Drawing.FontStyle.Underline));
			this.label8.Location = new System.Drawing.Point(136, 216);
			this.label8.Name = "label8";
			this.label8.Size = new System.Drawing.Size(104, 24);
			this.label8.TabIndex = 8;
			this.label8.Text = "Thumbnails";
			// 
			// picGraphicsSettingsText
			// 
			this.picGraphicsSettingsText.Location = new System.Drawing.Point(256, 160);
			this.picGraphicsSettingsText.Name = "picGraphicsSettingsText";
			this.picGraphicsSettingsText.Size = new System.Drawing.Size(344, 24);
			this.picGraphicsSettingsText.TabIndex = 10;
			// 
			// thumbnailGraphicsSettingsText
			// 
			this.thumbnailGraphicsSettingsText.Location = new System.Drawing.Point(256, 216);
			this.thumbnailGraphicsSettingsText.Name = "thumbnailGraphicsSettingsText";
			this.thumbnailGraphicsSettingsText.Size = new System.Drawing.Size(344, 24);
			this.thumbnailGraphicsSettingsText.TabIndex = 10;
			// 
			// picGraphicsSettingsButton
			// 
			this.picGraphicsSettingsButton.Location = new System.Drawing.Point(632, 160);
			this.picGraphicsSettingsButton.Name = "picGraphicsSettingsButton";
			this.picGraphicsSettingsButton.Size = new System.Drawing.Size(24, 23);
			this.picGraphicsSettingsButton.TabIndex = 5;
			this.picGraphicsSettingsButton.Text = "...";
			this.picGraphicsSettingsButton.Click += new System.EventHandler(this.picGraphicsSettingsButton_Click);
			// 
			// thumbnailGraphicsSettingsButton
			// 
			this.thumbnailGraphicsSettingsButton.Location = new System.Drawing.Point(632, 216);
			this.thumbnailGraphicsSettingsButton.Name = "thumbnailGraphicsSettingsButton";
			this.thumbnailGraphicsSettingsButton.Size = new System.Drawing.Size(24, 23);
			this.thumbnailGraphicsSettingsButton.TabIndex = 6;
			this.thumbnailGraphicsSettingsButton.Text = "...";
			this.thumbnailGraphicsSettingsButton.Click += new System.EventHandler(this.thumbnailGraphicsSettingsButton_Click);
			// 
			// Form1
			// 
			this.AutoScaleBaseSize = new System.Drawing.Size(5, 13);
			this.ClientSize = new System.Drawing.Size(800, 326);
			this.Controls.AddRange(new System.Windows.Forms.Control[] {
																		  this.picGraphicsSettingsText,
																		  this.label7,
																		  this.chooseInputFolderButton,
																		  this.doItButton,
																		  this.inFolderNameTextBox,
																		  this.label1,
																		  this.label2,
																		  this.outFolderNameTextBox,
																		  this.chooseOutputFolderButton,
																		  this.label8,
																		  this.thumbnailGraphicsSettingsText,
																		  this.picGraphicsSettingsButton,
																		  this.thumbnailGraphicsSettingsButton});
			this.Name = "Form1";
			this.Text = "Form1";
			this.ResumeLayout(false);

		}
		#endregion

		/// <summary>
		/// The main entry point for the application.
		/// </summary>
		[STAThread]
		static void Main() 
		{
			Application.Run(new Form1());
		}

		private void chooseInputFolderButton_Click(object sender, System.EventArgs e)
		{
			DirectorySelect dirsel = new DirectorySelect();
			dirsel.ShowDialog();
			inFolderNameTextBox.Text = dirsel.ReturnPath + "\\";		
		}

		private void chooseOutputFolderButton_Click(object sender, System.EventArgs e)
		{
			DirectorySelect dirsel = new DirectorySelect();
			dirsel.ShowDialog();
			outFolderNameTextBox.Text = dirsel.ReturnPath + "\\";
		}

		private void numberTextBox_Validating(object sender, System.ComponentModel.CancelEventArgs e)
		{
			try 
			{
				int tmp = Convert.ToInt32(((System.Windows.Forms.TextBox)sender).Text);
			} 
			catch 
			{
				MessageBox.Show("Please enter a valid number");
				e.Cancel = true;
			}
		
		}

		private void doItButton_Click(object sender, System.EventArgs e)
		{
			//try 
			{
				if (!inFolderNameTextBox.Text.EndsWith("\\"))
					inFolderNameTextBox.Text += '\\';
				if (!outFolderNameTextBox.Text.EndsWith("\\"))
					outFolderNameTextBox.Text += '\\';

				if (!Directory.Exists(inFolderNameTextBox.Text)) 
				{
					MessageBox.Show("please pick an input directory that exists");
					throw(new DirectoryNotFoundException());
				}
				if (!Directory.Exists(outFolderNameTextBox.Text)) 
				{
					Directory.CreateDirectory(outFolderNameTextBox.Text);
				}
				HTMLGen htmlGen = new HTMLGen(outFolderNameTextBox.Text, "index.htm", "images", "thumbnails",
					pictureGraphicsSettings, thumbnailGraphicsSettings);
				int numJpegs = System.IO.Directory.GetFiles(inFolderNameTextBox.Text, "*.jpg").Length;
				string [] fileEntries = new String[numJpegs];
				Array.Copy(System.IO.Directory.GetFiles(inFolderNameTextBox.Text, "*.jpg"), 0, fileEntries, 0, numJpegs);
				foreach(string fileName in fileEntries)
					htmlGen.AddPicture(fileName);
				htmlGen.Close();
				Application.Exit();

			} 
			//catch 
			{
			//	MessageBox.Show("processing failed.");
			}
			//finally 
			{
			}
		}

		private void picGraphicsSettingsButton_Click(object sender, System.EventArgs e)
		{
			GraphicsSettingsDialog gd = new GraphicsSettingsDialog("Picture settings", pictureGraphicsSettings);
			if (gd.ShowDialog(this) == DialogResult.OK) 
			{
				pictureGraphicsSettings = gd.GetSettings();
				picGraphicsSettingsText.Text = pictureGraphicsSettings.GetSettingsAsText();
			}
		}

		private void thumbnailGraphicsSettingsButton_Click(object sender, System.EventArgs e)
		{
			GraphicsSettingsDialog gd = new GraphicsSettingsDialog("Thumbnail settings", thumbnailGraphicsSettings);
			if (gd.ShowDialog(this) == DialogResult.OK) 
			{
				thumbnailGraphicsSettings = gd.GetSettings();
				thumbnailGraphicsSettingsText.Text = thumbnailGraphicsSettings.GetSettingsAsText();
			}
		}


	}

	public class HTMLGen 
	{
		private string m_directory;
		private StreamWriter m_htmlStream;
		private System.Web.UI.HtmlTextWriter m_htmlWriter;
		private string m_imagesDir;
		private string m_thumbnailsDir;
		private int m_col = 0;
		private GraphicsSettings m_imageGraphicsSettings, m_thumbnailGraphicsSettings;
		private String m_imageFileNameSuffix, m_thumbnailFileNameSuffix;

		public HTMLGen(string dirName, string htmlName, string imagesDirName, string thumbnailsDirName,
			GraphicsSettings imageGraphicsSettings, GraphicsSettings thumbnailGraphicsSettings)
		{
			//try 
			{
				m_imageGraphicsSettings = imageGraphicsSettings;
				m_thumbnailGraphicsSettings = thumbnailGraphicsSettings;
				if (m_imageGraphicsSettings.Codec == CodecChoice.jpeg)
					m_imageFileNameSuffix = ".jpg";
				else
					m_imageFileNameSuffix = ".png";
				if (m_thumbnailGraphicsSettings.Codec == CodecChoice.jpeg)
					m_thumbnailFileNameSuffix = ".jpg";
				else
					m_thumbnailFileNameSuffix = ".png";
				m_directory = dirName;
				if (File.Exists(dirName + htmlName))
					File.Delete(dirName + htmlName);
				m_htmlStream = File.CreateText(dirName + htmlName);
				m_htmlWriter = new System.Web.UI.HtmlTextWriter(m_htmlStream);
				m_imagesDir = imagesDirName;
				m_thumbnailsDir = thumbnailsDirName;

				if (Directory.Exists(m_directory + m_imagesDir) || Directory.Exists(m_directory + m_thumbnailsDir)) 
				{
					MessageBox.Show("output directories aren't empty");
					throw(new IOException());
				}
				Directory.CreateDirectory(m_directory + m_imagesDir);
				Directory.CreateDirectory(m_directory + m_thumbnailsDir);
				m_htmlWriter.WriteFullBeginTag("HTML");
				m_htmlWriter.WriteFullBeginTag("HEAD");
				m_htmlWriter.WriteFullBeginTag("TITLE");
				m_htmlWriter.Write("some pictures");
				m_htmlWriter.WriteEndTag("TITLE");
				m_htmlWriter.WriteEndTag("HEAD");
				m_htmlWriter.WriteFullBeginTag("BODY");
				m_htmlWriter.WriteLine();
				m_htmlWriter.WriteFullBeginTag("CENTER");
				m_htmlWriter.WriteBeginTag("TABLE");
				m_htmlWriter.WriteAttribute("border", "1");
				m_htmlWriter.WriteAttribute("cellpadding", "0");
				m_htmlWriter.WriteAttribute("cellspacing", "2");
				m_htmlWriter.Write(HtmlTextWriter.TagRightChar);
				m_htmlWriter.WriteLine();
			}
			//finally 
			{
			}
		}

		public void AddPicture(string path)
		{
			ImageScaled newThumbnailImage, newImage;
			if (0 == m_col)
				NewRow();
			m_htmlWriter.WriteBeginTag("TD");
			m_htmlWriter.WriteAttribute("valign", "top");
			m_htmlWriter.WriteAttribute("align", "center");
			m_htmlWriter.WriteAttribute("width", "25%");
			m_htmlWriter.Write(HtmlTextWriter.TagRightChar);
			newImage = new ImageScaled(path, m_imageGraphicsSettings);
			newThumbnailImage = new ImageScaled(path, m_thumbnailGraphicsSettings);

			string newFilename = path;
			newFilename = path.Remove(0, path.LastIndexOf('\\') + 1);
			newFilename = newFilename.Remove(newFilename.LastIndexOf(".jpg"), 4);

			newThumbnailImage.Save(m_directory + m_thumbnailsDir + "\\" + newFilename + m_thumbnailFileNameSuffix);
			newImage.Save(m_directory + m_imagesDir + "\\" + newFilename + m_imageFileNameSuffix);

			m_htmlWriter.WriteBeginTag("A");
			m_htmlWriter.WriteAttribute("HREF", m_imagesDir + "/" + newFilename + m_imageFileNameSuffix);
			m_htmlWriter.Write(HtmlTextWriter.TagRightChar);
			m_htmlWriter.WriteBeginTag("IMG");
			m_htmlWriter.WriteAttribute("alt", newFilename);
			m_htmlWriter.WriteAttribute("src", m_thumbnailsDir + "/" + newFilename + m_thumbnailFileNameSuffix);
			m_htmlWriter.Write(HtmlTextWriter.TagRightChar);
			m_htmlWriter.WriteFullBeginTag("BR");
			m_htmlWriter.Write(newFilename);
			m_htmlWriter.WriteEndTag("A");
			m_htmlWriter.WriteEndTag("TD");
			m_htmlWriter.WriteLine();
			if (++m_col == 4) 
			{
				EndRow();
				m_col = 0;
			}
		}

		public void Close()
		{
			m_htmlWriter.WriteEndTag("TABLE");
			m_htmlWriter.WriteEndTag("CENTER");
			m_htmlWriter.WriteLine();
			m_htmlWriter.WriteEndTag("BODY");
			m_htmlWriter.WriteEndTag("HTML");
			m_htmlStream.Close();
		}

		private void NewRow()
		{
			m_htmlWriter.WriteFullBeginTag("TR");
		}

		private void EndRow()
		{
			m_htmlWriter.WriteEndTag("TR");
		}

		
	}

	public class ImageScaled  
	{
		private Image m_bm;
		private Rectangle m_drawRect = new Rectangle(0, 0, 0, 0);
		private GraphicsSettings m_gs;
		public ImageScaled(string fileName, GraphicsSettings gs) 
		{
			m_gs = gs;
			m_bm = Image.FromFile(fileName);
			if (m_bm != null) 
			{
				m_drawRect = new Rectangle(0, 0, 0, 0);
				float hScale, wScale, scale;
				wScale = (float)gs.Width / (float)m_bm.Width;
				hScale = (float)gs.Height / (float)m_bm.Height;
				if (wScale < hScale)
					scale = wScale;
				else
					scale = hScale;

				m_drawRect.Width = (int)(scale * m_bm.Width);
				m_drawRect.Height = (int)(scale * m_bm.Height);
			}

		}

		public void Save(string filename) 
		{
			Graphics g;
			EncoderParameters myParams = new System.Drawing.Imaging.EncoderParameters(1);
			Encoder quality;
			EncoderParameter qualityParam;
			ImageCodecInfo myCodec;

			if (m_gs.Codec == CodecChoice.jpeg)
				myCodec = GetEncoderInfo("image/jpeg");
			else
				myCodec = GetEncoderInfo("image/png");
			quality = Encoder.Quality;
			qualityParam = new EncoderParameter(quality, m_gs.Quality);
			myParams.Param[0] = qualityParam;
			Bitmap newbm = new Bitmap(m_drawRect.Width, m_drawRect.Height, System.Drawing.Imaging.PixelFormat.Format32bppArgb);
			g = Graphics.FromImage(newbm);
			g.DrawImage(m_bm, m_drawRect);
			newbm.Save(filename, myCodec, myParams);
			g.Dispose();
			newbm.Dispose();
		}

		private static ImageCodecInfo GetEncoderInfo(String mimeType)
		{
			int j;
			ImageCodecInfo[] encoders;
			encoders = ImageCodecInfo.GetImageEncoders();
			for(j = 0; j < encoders.Length; ++j)
			{
				if(encoders[j].MimeType == mimeType)
					return encoders[j];
			}
			return null;
		}
	}


	public class DirectorySelect : FolderNameEditor 
	{
		private FolderBrowser   m_fb = new 	FolderBrowser();
		private string     m_description = "Select Folder";
		private string     m_returnPath = string.Empty;

		public DirectorySelect() 
		{
		}

		public string Description 
		{
			get 
			{
				return m_description;
			}
			set 
			{
				m_description = value;
			}
		}

		public string ReturnPath 
		{
			get 
			{
				return m_returnPath;
			}
		}

		public DialogResult RunDialog() 
		{
			m_fb.Description = m_description;
			m_fb.StartLocation = FolderBrowserFolder.Desktop;
			return m_fb.ShowDialog();
		}

		public DialogResult ShowDialog() 
		{
			DialogResult dr = DialogResult.None;
			dr = RunDialog();
			if(dr == DialogResult.OK) 
			{
				m_returnPath = m_fb.DirectoryPath;
			} 
			else 
			{
				m_returnPath = string.Empty;
			} return dr;
		} 
	}
}
